##// END OF EJS Templates
y
Unknown -
r615:24279544f428
parent child
Show More
@@ -1,892 +1,892
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62 62
63 63 # Kernel deb packages for 32bit kernel
64 64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 68 # Default precompiled 64bit kernel
69 69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 70 # Generic
71 71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72 72 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
73 73 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
74 74
75 75 # Build directories
76 76 WORKDIR=$(pwd)
77 77 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
78 78 BUILDDIR="${BASEDIR}/build"
79 79
80 80 # Chroot directories
81 81 R="${BUILDDIR}/chroot"
82 82 ETC_DIR="${R}/etc"
83 83 LIB_DIR="${R}/lib"
84 84 BOOT_DIR="${R}/boot/firmware"
85 85 KERNEL_DIR="${R}/usr/src/linux"
86 86 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
87 87 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
88 88
89 89 # Firmware directory: Blank if download from github
90 90 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
91 91
92 92 # General settings
93 93 SET_ARCH=${SET_ARCH:=32}
94 94 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
95 95 PASSWORD=${PASSWORD:=raspberry}
96 96 USER_PASSWORD=${USER_PASSWORD:=raspberry}
97 97 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
98 98 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
99 99 EXPANDROOT=${EXPANDROOT:=true}
100 100
101 101 # Keyboard settings
102 102 XKB_MODEL=${XKB_MODEL:=""}
103 103 XKB_LAYOUT=${XKB_LAYOUT:=""}
104 104 XKB_VARIANT=${XKB_VARIANT:=""}
105 105 XKB_OPTIONS=${XKB_OPTIONS:=""}
106 106
107 107 # Network settings (DHCP)
108 108 ENABLE_DHCP=${ENABLE_DHCP:=true}
109 109
110 110 # Network settings (static)
111 111 NET_ADDRESS=${NET_ADDRESS:=""}
112 112 NET_GATEWAY=${NET_GATEWAY:=""}
113 113 NET_DNS_1=${NET_DNS_1:=""}
114 114 NET_DNS_2=${NET_DNS_2:=""}
115 115 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
116 116 NET_NTP_1=${NET_NTP_1:=""}
117 117 NET_NTP_2=${NET_NTP_2:=""}
118 118
119 119 # APT settings
120 120 APT_PROXY=${APT_PROXY:=""}
121 121 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
122 122 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
123 123
124 124 # Feature settings
125 125 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
126 126 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
127 127 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
128 128 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
129 129 ENABLE_I2C=${ENABLE_I2C:=false}
130 130 ENABLE_SPI=${ENABLE_SPI:=false}
131 131 ENABLE_IPV6=${ENABLE_IPV6:=true}
132 132 ENABLE_SSHD=${ENABLE_SSHD:=true}
133 133 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
134 134 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
135 135 ENABLE_SOUND=${ENABLE_SOUND:=true}
136 136 ENABLE_DBUS=${ENABLE_DBUS:=true}
137 137 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
138 138 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
139 139 ENABLE_XORG=${ENABLE_XORG:=false}
140 140 ENABLE_WM=${ENABLE_WM:=""}
141 141 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
142 142 ENABLE_USER=${ENABLE_USER:=true}
143 143 USER_NAME=${USER_NAME:="pi"}
144 144 ENABLE_ROOT=${ENABLE_ROOT:=false}
145 145 ENABLE_QEMU=${ENABLE_QEMU:=false}
146 146 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
147 147 ENABLE_KEYGEN=${ENABLE_KEYGEN:=true}
148 148
149 149 # SSH settings
150 150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
151 151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
152 152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
153 153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
154 154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
155 155
156 156 # Advanced settings
157 157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
158 158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
163 163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
164 164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
165 165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
166 166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
167 167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
168 168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
169 169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
170 170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
171 171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
172 172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
173 173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
174 174 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
175 175 ENABLE_LOGO=${ENABLE_LOGO:=true}
176 176 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
177 177 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
178 178
179 179 # Kernel compilation settings
180 180 BUILD_KERNEL=${BUILD_KERNEL:=true}
181 181 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
182 182 KERNEL_THREADS=${KERNEL_THREADS:=1}
183 183 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
184 184 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
185 185 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
186 186 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
187 187 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
188 188 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
189 189 KERNEL_VIRT=${KERNEL_VIRT:=false}
190 190 KERNEL_BPF=${KERNEL_BPF:=false}
191 191 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
192 192 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
193 193 KERNEL_NF=${KERNEL_NF:=false}
194 194
195 195 # Kernel compilation from source directory settings
196 196 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
197 197 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
198 198 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
199 199 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
200 200
201 201 # Reduce disk usage settings
202 202 REDUCE_APT=${REDUCE_APT:=true}
203 203 REDUCE_DOC=${REDUCE_DOC:=true}
204 204 REDUCE_MAN=${REDUCE_MAN:=true}
205 205 REDUCE_VIM=${REDUCE_VIM:=false}
206 206 REDUCE_BASH=${REDUCE_BASH:=false}
207 207 REDUCE_HWDB=${REDUCE_HWDB:=true}
208 208 REDUCE_SSHD=${REDUCE_SSHD:=true}
209 209 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
210 210
211 211 # Encrypted filesystem settings
212 212 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
213 213 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
214 214 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
215 215 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
216 216 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
217 217 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
218 218 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
219 219 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
220 220 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
221 221
222 222 # Chroot scripts directory
223 223 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
224 224
225 225 # Packages required in the chroot build environment
226 226 APT_INCLUDES=${APT_INCLUDES:=""}
227 227 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
228 228
229 229 # Packages to exclude from chroot build environment
230 230 APT_EXCLUDES=${APT_EXCLUDES:=""}
231 231
232 232 # Packages required for bootstrapping
233 233 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
234 234 #Requierd=netselect-apt
235 235 MISSING_PACKAGES=""
236 236
237 237 # Packages installed for c/c++ build environment in chroot (keep empty)
238 238 COMPILER_PACKAGES=""
239 239
240 240 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
241 241 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
242 242 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
243 243 APT_PROXY=http://127.0.0.1:3142/
244 244 fi
245 245
246 246 # netselect-apt does not know buster yet
247 247 #if [ "$RELEASE" = "buster" ] ; then
248 248 # RLS=testing
249 249 #else
250 250 # RLS="$RELEASE"
251 251 #fi
252 252
253 253 #if [ -f "$(pwd)/files/apt/sources.list" ] ; then
254 254 #rm "$(pwd)/files/apt/sources.list"
255 255 #fi
256 256
257 257 #if [ "$ENABLE_NONFREE" = true ] ; then
258 258 # netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
259 259 #else
260 260 # netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
261 261 #fi
262 262
263 263 # sed and cut the result string so we can use it as APT_SERVER
264 264 #APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
265 265
266 266 # make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
267 267 if [ -n "$SET_ARCH" ] ; then
268 268 # 64-bit configuration
269 269 if [ "$SET_ARCH" = 64 ] ; then
270 270 # General 64-bit depended settings
271 271 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
272 272 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
273 273 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
274 274
275 275 # Raspberry Pi model specific settings
276 276 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
277 277 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
278 278 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
279 279 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
280 280 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
281 281 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
282 282 else
283 283 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
284 284 exit 1
285 285 fi
286 286 fi
287 287
288 288 # 32-bit configuration
289 289 if [ "$SET_ARCH" = 32 ] ; then
290 290 # General 32-bit dependend settings
291 291 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
292 292 KERNEL_ARCH=${KERNEL_ARCH:=arm}
293 293 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
294 294
295 295 # Raspberry Pi model specific settings
296 296 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
297 297 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
298 298 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
299 299 RELEASE_ARCH=${RELEASE_ARCH:=armel}
300 300 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
301 301 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
302 302 fi
303 303
304 304 # Raspberry Pi model specific settings
305 305 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
306 306 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
307 307 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
308 308 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
309 309 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
310 310 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
311 311 fi
312 312 fi
313 313 # SET_ARCH not set
314 314 else
315 315 echo "error: Please set '32' or '64' as value for SET_ARCH"
316 316 exit 1
317 317 fi
318 318 # Device specific configuration and U-Boot configuration
319 319 case "$RPI_MODEL" in
320 320 0)
321 321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
322 322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
323 323 ;;
324 324 1)
325 325 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
326 326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
327 327 ;;
328 328 1P)
329 329 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
330 330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
331 331 ;;
332 332 2)
333 333 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
334 334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
335 335 ;;
336 336 3)
337 337 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
338 338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
339 339 ;;
340 340 3P)
341 341 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
342 342 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
343 343 ;;
344 344 *)
345 345 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
346 346 exit 1
347 347 ;;
348 348 esac
349 349
350 350 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
351 351 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
352 352 # Include bluetooth packages on supported boards
353 353 if [ "$ENABLE_BLUETOOTH" = true ] ; then
354 354 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
355 355 fi
356 356 if [ "$ENABLE_WIRELESS" = true ] ; then
357 357 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,firmware-brcm80211"
358 358 fi
359 359 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
360 360 # Check if the internal wireless interface is not supported by the RPi model
361 361 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
362 362 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
363 363 exit 1
364 364 fi
365 365 fi
366 366
367 367 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
368 368 echo "error: You have to compile kernel sources, if you want to enable nexmon"
369 369 exit 1
370 370 fi
371 371
372 372 # Prepare date string for default image file name
373 373 DATE="$(date +%Y-%m-%d)"
374 374 if [ -z "$KERNEL_BRANCH" ] ; then
375 375 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
376 376 else
377 377 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
378 378 fi
379 379
380 380 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
381 381 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
382 382 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
383 383 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
384 384 exit 1
385 385 fi
386 386 fi
387 387
388 388 set +x
389 389
390 390 # Add cmake to compile videocore sources
391 391 if [ "$ENABLE_KEYGEN" = true ] ; then
392 392 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} perl"
393 393 fi
394 394
395 395 # Add cmake to compile videocore sources
396 396 if [ "$ENABLE_VIDEOCORE" = true ] ; then
397 397 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
398 398 fi
399 399
400 400 # Add deps for nexmon
401 401 if [ "$ENABLE_NEXMON" = true ] ; then
402 402 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
403 403 fi
404 404
405 405 # Add libncurses5 to enable kernel menuconfig
406 406 if [ "$KERNEL_MENUCONFIG" = true ] ; then
407 407 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
408 408 fi
409 409
410 410 # Add ccache compiler cache for (faster) kernel cross (re)compilation
411 411 if [ "$KERNEL_CCACHE" = true ] ; then
412 412 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
413 413 fi
414 414
415 415 # Add cryptsetup package to enable filesystem encryption
416 416 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
417 417 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
418 418 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
419 419
420 420 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
421 421 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
422 422 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
423 423 fi
424 424
425 425 if [ -z "$CRYPTFS_PASSWORD" ] ; then
426 426 echo "error: no password defined (CRYPTFS_PASSWORD)!"
427 427 exit 1
428 428 fi
429 429 ENABLE_INITRAMFS=true
430 430 fi
431 431
432 432 # Add initramfs generation tools
433 433 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
434 434 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
435 435 fi
436 436
437 437 # Add device-tree-compiler required for building the U-Boot bootloader
438 438 if [ "$ENABLE_UBOOT" = true ] ; then
439 439 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
440 440 fi
441 441
442 442 if [ "$ENABLE_USBBOOT" = true ] ; then
443 443 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
444 444 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
445 445 exit 1
446 446 fi
447 447 fi
448 448
449 449 # Check if root SSH (v2) public key file exists
450 450 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
451 451 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
452 452 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
453 453 exit 1
454 454 fi
455 455 fi
456 456
457 457 # Check if $USER_NAME SSH (v2) public key file exists
458 458 if [ -n "$SSH_USER_PUB_KEY" ] ; then
459 459 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
460 460 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
461 461 exit 1
462 462 fi
463 463 fi
464 464
465 465 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
466 466 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
467 467 exit 1
468 468 fi
469 469
470 470 # Check if all required packages are installed on the build system
471 471 for package in $REQUIRED_PACKAGES ; do
472 472 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
473 473 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
474 474 fi
475 475 done
476 476
477 477 # If there are missing packages ask confirmation for install, or exit
478 478 if [ -n "$MISSING_PACKAGES" ] ; then
479 479 echo "the following packages needed by this script are not installed:"
480 480 echo "$MISSING_PACKAGES"
481 481
482 482 printf "\ndo you want to install the missing packages right now? [y/n] "
483 483 read -r confirm
484 484 [ "$confirm" != "y" ] && exit 1
485 485
486 486 # Make sure all missing required packages are installed
487 487 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
488 488 fi
489 489
490 490 # Check if ./bootstrap.d directory exists
491 491 if [ ! -d "./bootstrap.d/" ] ; then
492 492 echo "error: './bootstrap.d' required directory not found!"
493 493 exit 1
494 494 fi
495 495
496 496 # Check if ./files directory exists
497 497 if [ ! -d "./files/" ] ; then
498 498 echo "error: './files' required directory not found!"
499 499 exit 1
500 500 fi
501 501
502 502 # Check if specified KERNELSRC_DIR directory exists
503 503 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
504 504 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
505 505 exit 1
506 506 fi
507 507
508 508 # Check if specified UBOOTSRC_DIR directory exists
509 509 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
510 510 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
511 511 exit 1
512 512 fi
513 513
514 514 # Check if specified VIDEOCORESRC_DIR directory exists
515 515 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
516 516 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
517 517 exit 1
518 518 fi
519 519
520 520 # Check if specified FBTURBOSRC_DIR directory exists
521 521 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
522 522 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
523 523 exit 1
524 524 fi
525 525
526 526 # Check if specified NEXMONSRC_DIR directory exists
527 527 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
528 528 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
529 529 exit 1
530 530 fi
531 531
532 532 # Check if specified CHROOT_SCRIPTS directory exists
533 533 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
534 534 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
535 535 exit 1
536 536 fi
537 537
538 538 # Check if specified device mapping already exists (will be used by cryptsetup)
539 539 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
540 540 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
541 541 exit 1
542 542 fi
543 543
544 544 # Don't clobber an old build
545 545 if [ -e "$BUILDDIR" ] ; then
546 546 echo "error: directory ${BUILDDIR} already exists, not proceeding"
547 547 exit 1
548 548 fi
549 549
550 550 # Setup chroot directory
551 551 mkdir -p "${R}"
552 552
553 553 # Check if build directory has enough of free disk space >512MB
554 554 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
555 555 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
556 556 exit 1
557 557 fi
558 558
559 559 set -x
560 560
561 561 # Call "cleanup" function on various signals and errors
562 562 trap cleanup 0 1 2 3 6
563 563
564 564 # Add required packages for the minbase installation
565 565 if [ "$ENABLE_MINBASE" = true ] ; then
566 566 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
567 567 fi
568 568
569 569 # Add parted package, required to get partprobe utility
570 570 if [ "$EXPANDROOT" = true ] ; then
571 571 APT_INCLUDES="${APT_INCLUDES},parted"
572 572 fi
573 573
574 574 # Add dbus package, recommended if using systemd
575 575 if [ "$ENABLE_DBUS" = true ] ; then
576 576 APT_INCLUDES="${APT_INCLUDES},dbus"
577 577 fi
578 578
579 579 # Add iptables IPv4/IPv6 package
580 580 if [ "$ENABLE_IPTABLES" = true ] ; then
581 581 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
582 582 fi
583 583 # Add apparmor for KERNEL_SECURITY
584 584 if [ "$KERNEL_SECURITY" = true ] ; then
585 585 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
586 586 fi
587 587
588 588 # Add openssh server package
589 589 if [ "$ENABLE_SSHD" = true ] ; then
590 590 APT_INCLUDES="${APT_INCLUDES},openssh-server"
591 591 fi
592 592
593 593 # Add alsa-utils package
594 594 if [ "$ENABLE_SOUND" = true ] ; then
595 595 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
596 596 fi
597 597
598 598 # Add rng-tools package
599 599 if [ "$ENABLE_HWRANDOM" = true ] ; then
600 600 APT_INCLUDES="${APT_INCLUDES},rng-tools"
601 601 fi
602 602
603 603 # Add fbturbo video driver
604 604 if [ "$ENABLE_FBTURBO" = true ] ; then
605 605 # Enable xorg package dependencies
606 606 ENABLE_XORG=true
607 607 fi
608 608
609 609 # Add user defined window manager package
610 610 if [ -n "$ENABLE_WM" ] ; then
611 611 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
612 612
613 613 # Enable xorg package dependencies
614 614 ENABLE_XORG=true
615 615 fi
616 616
617 617 # Add xorg package
618 618 if [ "$ENABLE_XORG" = true ] ; then
619 619 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
620 620 fi
621 621
622 622 # Replace selected packages with smaller clones
623 623 if [ "$ENABLE_REDUCE" = true ] ; then
624 624 # Add levee package instead of vim-tiny
625 625 if [ "$REDUCE_VIM" = true ] ; then
626 626 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
627 627 fi
628 628
629 629 # Add dropbear package instead of openssh-server
630 630 if [ "$REDUCE_SSHD" = true ] ; then
631 631 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
632 632 fi
633 633 fi
634 634
635 635 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
636 636 if [ "$ENABLE_SYSVINIT" = false ] ; then
637 637 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
638 638 fi
639 639
640 640 # Configure kernel sources if no KERNELSRC_DIR
641 641 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
642 642 KERNELSRC_CONFIG=true
643 643 fi
644 644
645 645 # Configure reduced kernel
646 646 if [ "$KERNEL_REDUCE" = true ] ; then
647 647 KERNELSRC_CONFIG=false
648 648 fi
649 649
650 650 # Configure qemu compatible kernel
651 651 if [ "$ENABLE_QEMU" = true ] ; then
652 652 DTB_FILE=vexpress-v2p-ca15_a7.dtb
653 653 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
654 654 KERNEL_DEFCONFIG="vexpress_defconfig"
655 655 if [ "$KERNEL_MENUCONFIG" = false ] ; then
656 656 KERNEL_OLDDEFCONFIG=true
657 657 fi
658 658 fi
659 659
660 660 # Execute bootstrap scripts
661 661 for SCRIPT in bootstrap.d/*.sh; do
662 662 head -n 3 "$SCRIPT"
663 663 . "$SCRIPT"
664 664 done
665 665
666 666 ## Execute custom bootstrap scripts
667 667 if [ -d "custom.d" ] ; then
668 668 for SCRIPT in custom.d/*.sh; do
669 669 . "$SCRIPT"
670 670 done
671 671 fi
672 672
673 673 # Execute custom scripts inside the chroot
674 674 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
675 675 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
676 676 chroot_exec /bin/bash -x <<'EOF'
677 677 for SCRIPT in /chroot_scripts/* ; do
678 678 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
679 679 $SCRIPT
680 680 fi
681 681 done
682 682 EOF
683 683 rm -rf "${R}/chroot_scripts"
684 684 fi
685 685
686 686 # Remove c/c++ build environment from the chroot
687 687 chroot_remove_cc
688 688
689 689 # Generate required machine-id
690 690 MACHINE_ID=$(dbus-uuidgen)
691 691 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
692 692 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
693 693
694 694 # APT Cleanup
695 695 chroot_exec apt-get -y clean
696 696 chroot_exec apt-get -y autoclean
697 697 chroot_exec apt-get -y autoremove
698 698
699 699 # Unmount mounted filesystems
700 700 umount -l "${R}/proc"
701 701 umount -l "${R}/sys"
702 702
703 703 # Clean up directories
704 704 rm -rf "${R}/run/*"
705 705 rm -rf "${R}/tmp/*"
706 706
707 707 # Clean up APT proxy settings
708 708 if [ "$KEEP_APT_PROXY" = false ] ; then
709 709 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
710 710 fi
711 711
712 712 # Clean up files
713 713 rm -f "${ETC_DIR}/ssh/ssh_host_*"
714 714 rm -f "${ETC_DIR}/dropbear/dropbear_*"
715 715 rm -f "${ETC_DIR}/apt/sources.list.save"
716 716 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
717 717 rm -f "${ETC_DIR}/*-"
718 718 rm -f "${ETC_DIR}/resolv.conf"
719 719 rm -f "${R}/root/.bash_history"
720 720 rm -f "${R}/var/lib/urandom/random-seed"
721 721 rm -f "${R}/initrd.img"
722 722 rm -f "${R}/vmlinuz"
723 723 rm -f "${R}${QEMU_BINARY}"
724 724
725 725 if [ "$ENABLE_QEMU" = true ] ; then
726 726 # Setup QEMU directory
727 727 mkdir "${BASEDIR}/qemu"
728 728
729 729 # Copy kernel image to QEMU directory
730 730 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
731 731
732 732 # Copy kernel config to QEMU directory
733 733 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
734 734
735 735 # Copy kernel dtbs to QEMU directory
736 736 for dtb in "${BOOT_DIR}/"*.dtb ; do
737 737 if [ -f "${dtb}" ] ; then
738 738 install_readonly "${dtb}" "${BASEDIR}/qemu/"
739 739 fi
740 740 done
741 741
742 742 # Copy kernel overlays to QEMU directory
743 743 if [ -d "${BOOT_DIR}/overlays" ] ; then
744 744 # Setup overlays dtbs directory
745 745 mkdir "${BASEDIR}/qemu/overlays"
746 746
747 747 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
748 748 if [ -f "${dtb}" ] ; then
749 749 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
750 750 fi
751 751 done
752 752 fi
753 753
754 754 # Copy u-boot files to QEMU directory
755 755 if [ "$ENABLE_UBOOT" = true ] ; then
756 756 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
757 757 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
758 758 fi
759 759 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
760 760 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
761 761 fi
762 762 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
763 763 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
764 764 fi
765 765 fi
766 766
767 767 # Copy initramfs to QEMU directory
768 768 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
769 769 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
770 770 fi
771 771 fi
772 772
773 773 # Calculate size of the chroot directory in KB
774 774 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
775 775
776 776 # Calculate the amount of needed 512 Byte sectors
777 777 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
778 778 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
779 779 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
780 780
781 781 # The root partition is EXT4
782 782 # This means more space than the actual used space of the chroot is used.
783 783 # As overhead for journaling and reserved blocks 35% are added.
784 784 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
785 785
786 786 # Calculate required image size in 512 Byte sectors
787 787 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
788 788
789 789 # Prepare image file
790 790 if [ "$ENABLE_SPLITFS" = true ] ; then
791 791 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
792 792 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
793 793 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
794 794 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
795 795
796 796 # Write firmware/boot partition tables
797 797 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
798 798 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
799 799 EOM
800 800
801 801 # Write root partition table
802 802 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
803 803 ${TABLE_SECTORS},${ROOT_SECTORS},83
804 804 EOM
805 805
806 806 # Setup temporary loop devices
807 807 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
808 808 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
809 809 else # ENABLE_SPLITFS=false
810 810 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
811 811 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
812 812
813 813 # Write partition table
814 814 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
815 815 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
816 816 ${ROOT_OFFSET},${ROOT_SECTORS},83
817 817 EOM
818 818
819 819 # Setup temporary loop devices
820 820 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
821 821 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
822 822 fi
823 823
824 824 if [ "$ENABLE_CRYPTFS" = true ] ; then
825 825 # Create dummy ext4 fs
826 mkfs.ext4 "$ROOT_LOOP"
826 #mkfs.ext4 "$ROOT_LOOP"
827 827
828 828 # Setup password keyfile
829 829 touch .password
830 830 chmod 600 .password
831 831 echo -n ${CRYPTFS_PASSWORD} > .password
832 832
833 833 # Initialize encrypted partition
834 834 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
835 835
836 836 # Open encrypted partition and setup mapping
837 837 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
838 838
839 839 # Secure delete password keyfile
840 840 shred -zu .password
841 841
842 842 # Update temporary loop device
843 843 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
844 844
845 845 # Wipe encrypted partition (encryption cipher is used for randomness)
846 846 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
847 847 fi
848 848
849 849 # Build filesystems
850 850 mkfs.vfat "$FRMW_LOOP"
851 851 mkfs.ext4 "$ROOT_LOOP"
852 852
853 853 # Mount the temporary loop devices
854 854 mkdir -p "$BUILDDIR/mount"
855 855 mount "$ROOT_LOOP" "$BUILDDIR/mount"
856 856
857 857 mkdir -p "$BUILDDIR/mount/boot/firmware"
858 858 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
859 859
860 860 # Copy all files from the chroot to the loop device mount point directory
861 861 rsync -a "${R}/" "$BUILDDIR/mount/"
862 862
863 863 # Unmount all temporary loop devices and mount points
864 864 cleanup
865 865
866 866 # Create block map file(s) of image(s)
867 867 if [ "$ENABLE_SPLITFS" = true ] ; then
868 868 # Create block map files for "bmaptool"
869 869 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
870 870 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
871 871
872 872 # Image was successfully created
873 873 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
874 874 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
875 875 else
876 876 # Create block map file for "bmaptool"
877 877 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
878 878
879 879 # Image was successfully created
880 880 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
881 881
882 882 # Create qemu qcow2 image
883 883 if [ "$ENABLE_QEMU" = true ] ; then
884 884 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
885 885 QEMU_SIZE=16G
886 886
887 887 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
888 888 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
889 889
890 890 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
891 891 fi
892 892 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant